<?php
require_once "db.php";
function _my_errorfatal($s,$code=null,$die=true){
 $bta=debug_backtrace();
 $bt=var_export($bta,true);
 echo "<pre>ERROR: $s<br/>\n$code<br/>\n$bt<br/>\n</pre>";
 if ($die) die($s);
}

class Query_my extends Query {
 var $qry,$numflds,$fldtypes,$fldnames;
 function Query_my($_qry){
  $this->qry=$_qry;
  $this->numflds=mysql_num_fields($this->qry);
  $this->fldtypes=array();
  $this->fldnames=array();
  for($i=0;$i<$this->numflds;$i++) {
   $this->fldtypes[]=mysql_field_type($this->qry,$i);
   $this->fldnames[]=mysql_field_name($this->qry,$i);
  }
 }
 function _Query_my(){
  if (!is_null($this->qry)) mysql_free_result($this->qry);
  $this->qry=null;
 }
 function __destruct(){
  $this->_Query_my();
 }
 function fetchRow(){
  $rw=mysql_fetch_row($this->qry);
  return $rw;
 }
 function fetchAssoc(){
  $rw=mysql_fetch_assoc($this->qry);
  return $rw;
 }
 function get_numfields(){
  return $this->numflds;
 }
 function get_fieldname($fieldno){
  return $this->fldnames[$fieldno];
 }
}
class DB_my extends DB {
 var $con;
 var $started;
 var $cntq;
 var $silent_errors;
 var $in_tran;
 var $dump_q;
 function DB_my(){
  $this->con=null;
  $this->cntq=0;
  $this->silent_errors=false;
  $this->dump_q=false;
 }
 function _DB_my(){
  $this->disconnect();
 }
 function _prepsql($sql,$binds){
  if (!is_array($binds)) return $sql;
  if (count($binds)<1) return $sql;
  for($i=0;$i<count($binds);$i++){
  	$sql=preg_replace("/:".($i+1)."\\b/",chr(1).chr($i+1),$sql);
  }
  for($i=0;$i<count($binds);$i++){
   $sql=preg_replace("/\\x1\\x".dechex($i+1)."/",is_null($binds[$i]) ? 'null':"\"".mysql_real_escape_string ($binds[$i],$this->con)."\"",$sql);
  }
  return $sql;
 }
 function __destruct(){
  $this->disconnect();
 }
 function disconnect(){
  if (is_resource($this->con)) mysql_close($this->con);
  $this->con=null;
 }
 function connect($params){
  $dsn="";
  $this->started=microtime(true);
  $this->cntq=0;
  foreach($params as $k=>$v) $dsn.="$k=$v ";
  $this->con=mysql_connect($params['HOST'],$params['USER'],$params['PASSWORD']);
  if (!$this->con) _my_errorfatal(mysql_error($this->con));
  if (!mysql_select_db($params['DB'],$this->con)){
   $s=mysql_error($this->con);
   $this->disconnect();
   _my_errorfatal($s);
  }
  if (array_key_exists('CHARSET',$params))
  if (strlen($params['CHARSET'])>0){
    //mysql_query('SET character_set_client = \''.$params['CHARSET'].'\'',$this->con);
    //echo mysql_error($this->con);
    //mysql_query('SET names \''.$params['CHARSET'].'\'',$this->con);
    //echo mysql_error($this->con);
    mysql_set_charset($params['CHARSET'],$this->con);
  }
  $this->params=$params;
  $this->in_tran=false;
 }
 function transaction($ro=false){
  //if ($this->in_tran) 
  $this->commit();
  $this->in_tran=true;
  $this->cntq+=1;
 }
 function rollback(){
  //if (!$this->in_tran) return ;
  $this->in_tran=false;
  $this->cntq+=1;
  @mysql_query('rollback',$this->con);
 }
 function commit(){
  //if (!$this->in_tran) return ;
  $this->in_tran=false;
  $this->cntq+=1;
  if ($this->dump_q) echo "commit<br>\n";
  @mysql_query('commit',$this->con);
 }
 function execute($sql,$binds=null){
  $psql=$this->_prepsql($sql,$binds);
  if ($this->dump_q) echo htmlspecialchars($psql),"<br>\n";
  $res=mysql_query($psql,$this->con);
  if (!$res) {
   if ($this->silent_errors) return false;
   _my_errorfatal(mysql_error($this->con),$sql);
  }
  $this->cntq++;
  return true;
 }
 function query($sql,$binds=null){
  $psql=$this->_prepsql($sql,$binds);
  if ($this->dump_q) echo htmlspecialchars($psql),"<br>\n";
  $res=mysql_query($psql,$this->con);
  if (!$res) {
   if ($this->silent_errors) return null;
   _my_errorfatal(mysql_error($this->con),$sql);
  }
  $this->cntq++;
  $ret=new Query_my($res);
  return $ret;
 }
 function queryOneRow($sql,$binds=null){
  $psql=$this->_prepsql($sql,$binds);
  if ($this->dump_q) echo htmlspecialchars($psql),"<br>\n";
  $res=mysql_query($psql,$this->con);
  if (!$res) {
   if ($this->silent_errors) return null;
   _my_errorfatal(mysql_error($this->con),$sql);
  }
  $this->cntq++;
  $ret=mysql_fetch_row($res);
  mysql_free_result($res);
  if (!is_array($ret)) return null;
  if (count($ret)<1) return null;
  if (count($ret)==1) return $ret[0];
  return $ret;
 }
 function queryOneRowAssoc($sql,$binds=null){
  $psql=$this->_prepsql($sql,$binds);
  if ($this->dump_q) echo htmlspecialchars($psql),"<br>\n";
  $res=mysql_query($psql,$this->con);
  if (!$res) {
   if ($this->silent_errors) return null;
   _my_errorfatal(mysql_error($this->con),$sql);
  }
  $this->cntq++;
  $ret=mysql_fetch_assoc($res);
  mysql_free_result($res);
  return $ret;
 }
 function _getstat(){
  $nw=microtime(true);
  return $this->cntq.' queries '.($nw-$this->started).' secs';
 }
 function str_escape($s,$nulls=true){
	if (is_integer($s)) return $s;
	if ($nulls){
		if (is_null($s)) return "null";
		if ($s=="") return "null";
  }
  return "'".mysql_escape_string($s)."'";
 }
 function get_last_identity(){
 	return mysql_insert_id($this->con);
 }
 
}
?>
