<?php
$rdh=$_GET['rdh'];
$rdl=$_GET['rdl'];
$filter_array=array();
$filter=$_GET['filter'];

$netfmode=array(0=>'exact',1=>'subnets',2=>'supernets');


$mqg=get_magic_quotes_gpc();
function stss($s){
 global $mqg;
 if ($mqg) return stripslashes($s); else return $s;
}
if (strlen($filter)>0){
 $filter=stss($filter);
 $filter_array=json_decode($filter,true);
} else $filter_array=array();

if ($_SERVER['REQUEST_METHOD']=='POST'){
 $strs=array('rdh','rdl','siteh','sitel','ofsh','ofsl','rngh','rngl',
    'origin,','medl','medh','lpl','lph','aspath','comm','extcomm','history');
 foreach($strs as $stvn){
  $filter_array[$stvn]=$_POST[$stvn];
 }
 $filter_array['aspath']=stss($_POST['aspath']);
 $filter_array['comm']=stss($_POST['comm']);
 $filter_array['extcomm']=stss($_POST['extcomm']);
 $filter_array['history']=intval($_POST['history']);
 $filter=json_encode($filter_array);
}

$sql_from="select dtwhen,state,netaddrrdh,netaddrrdl,site,offset,srange,bgporigin,bgpaspath,bgpcommunities,
 bgpnexthop,bgpmed,bgplocalpref,bgpatomicaggregate,bgpaggregatoras,bgpagregatorIP,
 bgporiginatorIP,bgpextcom,bgplabels";

$use_log=(intval($filter_array['history'])!=0);
$sqlf="from bgp_l2vpn".($use_log ? '_log':'')." where srcid=".intval($srcid);
if (is_array($filter_array)){
 if (strlen($filter_array['rdh'])>0) $sqlf.=" and netaddrrdh=".intval($filter_array['rdh']);
 if (strlen($filter_array['rdl'])>0) $sqlf.=" and netaddrrdl=".intval($filter_array['rdl']);
 if (strlen($filter_array['siteh'])>0) $sqlf.=" and site<=".intval($filter_array['siteh']);
 if (strlen($filter_array['sitel'])>0) $sqlf.=" and site>=".intval($filter_array['sitel']);
 if (strlen($filter_array['ofsh'])>0) $sqlf.=" and offset<=".intval($filter_array['ofsh']);
 if (strlen($filter_array['ofsl'])>0) $sqlf.=" and offset>=".intval($filter_array['ofsl']);
 if (strlen($filter_array['rngh'])>0) $sqlf.=" and srange<=".intval($filter_array['rngh']);
 if (strlen($filter_array['rngl'])>0) $sqlf.=" and srange>=".intval($filter_array['rngl']);
 if (strlen($filter_array['origin'])>0){
   $sqlf.=" and bgporigin=".intval($filter_array['origin']);
 }
 if (strlen($filter_array['medl'])>0){
   $sqlf.=" and bgpmed>=".intval($filter_array['medl']);
 }
 if (strlen($filter_array['medh'])>0){
   $sqlf.=" and bgpmed<=".intval($filter_array['medh']);
 }
 if (strlen($filter_array['lpl'])>0){
   $sqlf.=" and bgplocalpref>=".intval($filter_array['lpl']);
 }
 if (strlen($filter_array['lph'])>0){
   $sqlf.=" and bgplocalpref<=".intval($filter_array['lph']);
 }
 if (strlen($filter_array['aspath'])>0){
   $sqlf.=" and bgpaspath rlike ".$db->str_escape($filter_array['aspath'],false);
 }
 if (strlen($filter_array['comm'])>0){
   $sqlf.=" and bgpcommunities rlike ".$db->str_escape($filter_array['comm'],false);
 }
 if (strlen($filter_array['extcomm'])>0){
   $sqlf.=" and bgpextcom rlike ".$db->str_escape($filter_array['extcomm'],false);
 }
} else $filter_array=array();

$cnt=$db->queryOneRow("select count(*) $sqlf");
$sql="$sql_from $sqlf order by dtwhen desc limit ".($pagesize*$pageno).','.$pagesize;
//echo myenc($sql);
$q=$db->query($sql);
echo "<table class='tbl' border=1>";
echo "<tr><th>Updated</th><th>RD</th><th>Site</th><th>Offset</th><th>Range</th><th>Nexthop</th><th>MED</th><th>Localpref</th><th>Origin</th><th>AS path</th><th>Communities</th>";
echo "<th>ExtCommunities</th><th>Originator</th><th>Atomic Aggregate</th><th>AggregatorAS</th><th>AggregatorIP</th><th>MPLS Labels</th></tr>\n";
$pageuri=myenc("?srcid=$srcid&safid=$safid&filter=".urlencode($filter)."&pageno=");
writepaging($pageno,$pagesize,$cnt,$pageuri,'|','<tr><td colspan=17>','</td></tr>');
$nt=new InetNet();
$na=new InetAddr();
while($r=$q->fetchAssoc()){
 $cls='';
 if ($r['state']==2) $cls=' style="color:red"';
 echo "<tr><td$cls>",myenc($r['dtwhen']),"</td>";
 echo "<td$cls>";//$r['netaddr'],'-',$r['netsize'],' * ',
 if (!$use_log) echo "<a href='?".myenc("safid=$safid&srcid=$srcid&rdh=".$r['netaddrrdh']."&rdl=".$r['netaddrrdl']."&netaddr=".$r['netaddr']."&netsize=".$r['netsize']),"'>";
 echo rd2str($r['netaddrrdh'],$r['netaddrrdl']);
 echo "</td><td$cls>";
 echo myenc($r['site']),"</td>";
 echo "</td><td$cls>";
 echo myenc($r['offset']),"</td>";
 echo "</td><td$cls>";
 echo myenc($r['srange']),"</td>";
 echo "<td$cls>";
 $na->assign($r['bgpnexthop']);
 echo myenc($na->str()),"</td>";
 echo "<td$cls>",myenc($r['bgpmed']),"</td>";
 echo "<td$cls>",myenc($r['bgplocalpref']),"</td>";
 echo "<td$cls>",myenc($r['bgporigin']),"</td>";
 echo "<td$cls>",myenc($r['bgpaspath']),"</td>";
 echo "<td$cls>",myenc($r['bgpcommunities']),"</td>";
 echo "<td$cls>",myenc($r['bgpextcom']),"</td>";
 $na->assign($r['bgporiginatorIP']);echo "<td$cls>",myenc($na->str()),"</td>";
 $na->assign($r['bgpatomicaggregate']);echo "<td$cls>",($r['bgpatomicaggregate'] ? myenc($na->str()):''),"</td>";
 echo "<td$cls>",myenc($r['bgpaggregatoras']),"</td>";
 $na->assign($r['bgpagregatorIP']);echo "<td$cls>",($r['bgpagregatorIP'] ? myenc($na->str()):''),"</td>";
 echo "<td$cls>",myenc($r['bgplabels']),"</td>";
 echo "</tr>\n";
}
writepaging($pageno,$pagesize,$cnt,$pageuri,'|','<tr><td colspan=17>','</td></tr>');
echo "</table>";
echo "<form method='post' action='?srcid=$srcid&amp;safid=$safid'>";
echo "<table class='tbl'>";
echo "<tr><th>RD</th><td><input type='text' name='rdh' value='".myenc($filter_array['rdh'])."'>:<input type='text' name='rdl' value='".myenc($filter_array['rdl'])."'></td></tr>\n";
echo "<tr><th>Site</th><td><input type='text' name='sitel' value='".myenc($filter_array['sitel'])."'>-<input type='text' name='siteh' value='".myenc($filter_array['siteh'])."'></td></tr>\n";
echo "<tr><th>Offset</th><td><input type='text' name='ofsl' value='".myenc($filter_array['ofsl'])."'>-<input type='text' name='ofsh' value='".myenc($filter_array['ofsh'])."'></td></tr>\n";
echo "<tr><th>Range</th><td><input type='text' name='rngl' value='".myenc($filter_array['rngl'])."'>-<input type='text' name='rngh' value='".myenc($filter_array['rngh'])."'></td></tr>\n";
echo "<tr><th>Origin</th><td><input type='text' name='origin' value='".myenc($filter_array['origin'])."'></td></tr>\n";
echo "<tr><th>MED</th><td><input type='text' name='medl' value='".myenc($filter_array['medl'])."'>-<input type='text' name='medh' value='".myenc($filter_array['medh'])."'></td></tr>\n";
echo "<tr><th>LocalPref</th><td><input type='text' name='lpl' value='".myenc($filter_array['lpl'])."'>-<input type='text' name='lph' value='".myenc($filter_array['lph'])."'></td></tr>\n";
echo "<tr><th>AS path</th><td><input type='text' name='aspath' value='".myenc($filter_array['aspath'])."'></td></tr>\n";
echo "<tr><th>Community</th><td><input type='text' name='comm' value='".myenc($filter_array['comm'])."'></td></tr>\n";
echo "<tr><th>ExtCommunity</th><td><input type='text' name='extcomm' value='".myenc($filter_array['extcomm'])."'></td></tr>\n";
echo "<tr><th>Use history log:</th><td><input type='checkbox' name='history' value='1'".(intval($filter_array['extcomm'])>0 ? ' checked':'')."'></td></tr>\n";
echo "<tr><th colspan=2><input type='submit'></td></tr>\n";
echo "</table></form>";
?>