<?php
require_once "ipaddr.php";
require_once "config.php";
if($config['DBTYPE']=='mysql') require_once "db_mysql.php";
$db=null;
function check_dbcon(){
	global $db,$config;
	if($config['DBTYPE']=='mysql') $db=new DB_my();
	$db->connect(array('USER'=>$config['DB_USER'],'PASSWORD'=>$config['DB_PASSWORD'],'DB'=>$config['DB_DBNAME'],'CHARSET'=>$config['DB_CHARSET'],'HOST'=>$config['DB_HOST']));
}
function rd2str($n1,$n2){
    if ($n1>=0x10000 && $n1<=0x1ffff){
        return sprintf("<%u.%u.%u.%u:%u>",($n1 >> 8) & 255,($n1 & 255),($n2 >> 24) & 255,($n2 >> 16) & 255,($n2 & 65535));
    }
    return sprintf("<%u:%u>",$n1,$n2);
}
function myenc($s){
 return htmlspecialchars($s,ENT_QUOTES);
}
function wrpagehead($title=null){
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<HTML>
 <HEAD>
  <TITLE>CDN<?php if ($title) echo "::",myenc($title); ?></TITLE>
  <link rel="stylesheet" type="text/css" href="def.css">
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<?php
}
function wrpagetop(){
 global $showalarms;
if (!$showalarms) return ;
echo "<div id='pagetop'>";
include "top.php";
?></div>
<script language='JavaScript'>
setTimeout('refresh_top()',60000);
</script>
<?php
}
function wrpagebottom(){
 global $showalarms,$userid,$_SESSION;
if (!$showalarms) return ;
echo "<div id='pagebottom'>";
include "bottom.php";
?></div>
<script language='JavaScript'>
setTimeout('refresh_bottom()',60000);
</script>
<?php
}

function writepaging($pageno,$pagesize,$cntall,$baseuri,$divider,$prefix,$postfix,$current=null){
 if (!$pagesize) $pagesize=10;
 if (is_null($current)) $current=array("<b>&gt;","&lt;</b>");
 if ($cntall<=$pagesize) return ;
 echo $prefix;
 $pages=(int)floor(($cntall+$pagesize-1)/$pagesize);
 $startp=0;$endp=$pages-1;
 echo "\n<!-- paging pageno=$pageno pagesize=$pagesize cntall=$cntall $startp-$endp -->\n";
 if ($pages>10) {
    $startp=$pageno-($pageno % 10);
    $endp=$startp+10;
    if ($endp>($pages-1)) $endp=$pages-1;
 }
 if ($startp>10) echo "<a href='$baseuri".'0'."'>&lt;&lt;</a>",$divider;
 if ($startp>0) echo "<a href='$baseuri".($startp-1)."'>&lt;</a>",$divider;
 for($i=$startp;$i<=$endp;$i++){
    if ($i==$pageno) echo $current[0],($i+1),$current[1]; else
     echo "<a href='$baseuri".$i."'>".($i+1)."</a>";
    if ($i<$endp) echo $divider;
 }
 if ($endp<($pages-1)) echo $divider,"<a href='$baseuri".($endp)."'>&gt;</a>",$divider,"<a href='$baseuri".($pages-1)."'>&gt;&gt;</a>";
 echo $postfix;
}

?>
