<?php
$rdh=$_GET['rdh'];
$rdl=$_GET['rdl'];
$netaddr=$_GET['netaddr'];
$netsize=intval($_GET['netsize']);
$filter_array=array();
$filter=$_GET['filter'];

$netfmode=array(0=>'exact',1=>'subnets',2=>'supernets');


$mqg=get_magic_quotes_gpc();
function stss($s){
 global $mqg;
 if ($mqg) return stripslashes($s); else return $s;
}
if (strlen($filter)>0){
 $filter=stss($filter);
 $filter_array=json_decode($filter,true);
} else $filter_array=array();

if ($_SERVER['REQUEST_METHOD']=='POST'){
 $filter_array['netf']=$_POST['netf'];
 $filter_array['netfmode']=$_POST['netfmode'];
 //$filter_array['nett']=$_POST['nett'];
 $filter_array['origin']=$_POST['origin'];
 $filter_array['medl']=$_POST['medl'];
 $filter_array['medh']=$_POST['medh'];
 $filter_array['lpl']=$_POST['lpl'];
 $filter_array['lph']=$_POST['lph'];
 $filter_array['aspath']=stss($_POST['aspath']);
 $filter_array['comm']=stss($_POST['comm']);
 $filter_array['extcomm']=stss($_POST['extcomm']);
 $filter_array['history']=intval($_POST['history']);
 $filter=json_encode($filter_array);
}

$sql_from="select dtwhen,state,netaddrrdh,netaddrrdl,netaddr,netsize,bgporigin,bgpaspath,bgpcommunities,
 nexthoprdh,nexthoprdl,nexthopip,bgpmed,bgplocalpref,bgpatomicaggregate,bgpaggregatoras,bgpagregatorIP,
 bgporiginatorIP,bgpextcom,bgplabels";

$use_log=(intval($filter_array['history'])!=0);
$sqlf="from bgp_vpnv4".($use_log ? '_log':'')." where srcid=".intval($srcid);
if (strlen($netaddr)>0) $sqlf.=" and netaddr=".intval($netaddr)." and netsize=".$netsize;
if (strlen($rdh)>0) $sqlf.=" and netaddrrdh=".intval($rdh);
if (strlen($rdl)>0) $sqlf.=" and netaddrrdl=".intval($rdl);
if (is_array($filter_array)){
 if (strlen($filter_array['netf'])>0){
  $netip=new InetNet();
  if ($netip->parse($filter_array['netf'])){
    $netip->normalize();
    if(intval($filter_array['netfmode'])==1){
        //subnets
        $netipa=new InetNet();
        $netipa->assign($netip);
        $netipa->increment();
        $sqlf.=" and netaddr>=".intval($netip->get_u1())." and netaddr<".intval($netipa->get_u1())." and netsize>=".intval($netip->preflen);
    }
    elseif(intval($filter_array['netfmode'])==2){
        //supernets
        $sqlf.=" and netaddr=(".intval($netip->get_u1())." & (((1 << (32-netsize))-1) ^ 4294967295))";
    }
    else {
        //exact
     $sqlf.=" and netaddr=".intval($netip->get_u1())." and netsize=".intval($netip->preflen);
    }
  }
 }
    /*
 if ((strlen($filter_array['netf'])>0) && (strlen($filter_array['nett'])>0)){
   $netf=new InetNet();
   $nett=new InetNet();
   if ($netf->parse($filter_array['netf']) && $nett->parse($filter_array['nett'])){
    $i1=$netf->get_u1();$i2=$nett->get_u1();
    if ($i1>$i2) {$i=$i1;$i1=$i2;$i2=$i;}
    $sqlf.=" and netaddr>=$i1 and netaddr<=$i2";
   }
 } elseif (strlen($filter_array['netf'])>0){
   $netip=new InetNet();
   if ($netip->parse($filter_array['netf'])){
    $sqlf.=" and netaddr=".intval($netip->get_u1())." and netsize=".intval($netip->preflen);
   }
 }
 */
 if (strlen($filter_array['origin'])>0){
   $sqlf.=" and bgporigin=".intval($filter_array['origin']);
 }
 if (strlen($filter_array['medl'])>0){
   $sqlf.=" and bgpmed>=".intval($filter_array['medl']);
 }
 if (strlen($filter_array['medh'])>0){
   $sqlf.=" and bgpmed<=".intval($filter_array['medh']);
 }
 if (strlen($filter_array['lpl'])>0){
   $sqlf.=" and bgplocalpref>=".intval($filter_array['lpl']);
 }
 if (strlen($filter_array['lph'])>0){
   $sqlf.=" and bgplocalpref<=".intval($filter_array['lph']);
 }
 if (strlen($filter_array['aspath'])>0){
   $sqlf.=" and bgpaspath rlike ".$db->str_escape($filter_array['aspath'],false);
 }
 if (strlen($filter_array['comm'])>0){
   $sqlf.=" and bgpcommunities rlike ".$db->str_escape($filter_array['comm'],false);
 }
 if (strlen($filter_array['extcomm'])>0){
   $sqlf.=" and bgpextcom rlike ".$db->str_escape($filter_array['extcomm'],false);
 }
} else $filter_array=array();

$cnt=$db->queryOneRow("select count(*) $sqlf");
$sql="$sql_from $sqlf order by dtwhen desc limit ".($pagesize*$pageno).','.$pagesize;
//echo myenc($sql);
$q=$db->query($sql);
echo "<table class='tbl' border=1>";
echo "<tr><th>Updated</th><th>Network</th><th>Nexthop</th><th>MED</th><th>Localpref</th><th>Origin</th><th>AS path</th><th>Communities</th>";
echo "<th>ExtCommunities</th><th>Originator</th><th>Atomic Aggregate</th><th>AggregatorAS</th><th>AggregatorIP</th><th>MPLS Labels</th></tr>\n";
$pageuri=myenc("?srcid=$srcid&safid=$safid&filter=".urlencode($filter)."&pageno=");
writepaging($pageno,$pagesize,$cnt,$pageuri,'|','<tr><td colspan=14>','</td></tr>');
$nt=new InetNet();
$na=new InetAddr();
while($r=$q->fetchAssoc()){
 $cls='';
 if ($r['state']==2) $cls=' style="color:red"';
 echo "<tr><td$cls>",myenc($r['dtwhen']),"</td>";
 $nt->assign($r['netaddr'],null,$r['netsize']);
 echo "<td$cls>";//$r['netaddr'],'-',$r['netsize'],' * ',
 if (!$use_log) echo "<a href='?".myenc("safid=$safid&srcid=$srcid&rdh=".$r['netaddrrdh']."&rdl=".$r['netaddrrdl']."&netaddr=".$r['netaddr']."&netsize=".$r['netsize']),"'>";
 echo rd2str($r['netaddrrdh'],$r['netaddrrdl']);
 echo myenc($nt->str()),($use_log ? '':'</a>'),"</td>";
 $na->assign($r['nexthopip']);
 echo "<td$cls>";
 if ($r['nexthoprdh']!=0 || $r['nexthoprdl']!=0) echo "<",$r['nexthoprdh'],":",$r['nexthoprdl'],"> ";
 echo myenc($na->str()),"</td>";
 echo "<td$cls>",myenc($r['bgpmed']),"</td>";
 echo "<td$cls>",myenc($r['bgplocalpref']),"</td>";
 echo "<td$cls>",myenc($r['bgporigin']),"</td>";
 echo "<td$cls>",myenc($r['bgpaspath']),"</td>";
 echo "<td$cls>",myenc($r['bgpcommunities']),"</td>";
 echo "<td$cls>",myenc($r['bgpextcom']),"</td>";
 $na->assign($r['bgporiginatorIP']);echo "<td$cls>",myenc($na->str()),"</td>";
 $na->assign($r['bgpatomicaggregate']);echo "<td$cls>",($r['bgpatomicaggregate'] ? myenc($na->str()):''),"</td>";
 echo "<td$cls>",myenc($r['bgpaggregatoras']),"</td>";
 $na->assign($r['bgpagregatorIP']);echo "<td$cls>",($r['bgpagregatorIP'] ? myenc($na->str()):''),"</td>";
 echo "<td$cls>",myenc($r['bgplabels']),"</td>";
 echo "</tr>\n";
}
writepaging($pageno,$pagesize,$cnt,$pageuri,'|','<tr><td colspan=14>','</td></tr>');
echo "</table>";
echo "<form method='post' action='?srcid=$srcid&amp;safid=$safid'>";
echo "<table class='tbl'>";
echo "<tr><th>Network</th><td><input type='text' name='netf' value='".myenc($filter_array['netf'])."'><select name='netfmode'>";
foreach($netfmode as $nmk=>$nmt){
    echo "<option value='",myenc($nmk),"'",($nmk==$filter_array['netfmode'] ? ' selected':''),">",myenc($nmt),"</option>\n";
}
echo "</select></td></tr>\n";
echo "<tr><th>Origin</th><td><input type='text' name='origin' value='".myenc($filter_array['origin'])."'></td></tr>\n";
echo "<tr><th>MED</th><td><input type='text' name='medl' value='".myenc($filter_array['medl'])."'>-<input type='text' name='medh' value='".myenc($filter_array['medh'])."'></td></tr>\n";
echo "<tr><th>LocalPref</th><td><input type='text' name='lpl' value='".myenc($filter_array['lpl'])."'>-<input type='text' name='lph' value='".myenc($filter_array['lph'])."'></td></tr>\n";
echo "<tr><th>AS path</th><td><input type='text' name='aspath' value='".myenc($filter_array['aspath'])."'></td></tr>\n";
echo "<tr><th>Community</th><td><input type='text' name='comm' value='".myenc($filter_array['comm'])."'></td></tr>\n";
echo "<tr><th>ExtCommunity</th><td><input type='text' name='extcomm' value='".myenc($filter_array['extcomm'])."'></td></tr>\n";
echo "<tr><th>Use history log:</th><td><input type='checkbox' name='history' value='1'".(intval($filter_array['extcomm'])>0 ? ' checked':'')."'></td></tr>\n";
echo "<tr><th colspan=2><input type='submit'></td></tr>\n";
echo "</table></form>";
?>